if pikachu == nil then pikachu = {} end
pikachu.wpnsnds = {}

pikachu.wpnsnds.wpntable = {
	[1] = "pikachu/wpn_deploy/usp_deploy.ogg",
	[2] = "pikachu/wpn_deploy/glock_deploy.ogg",
	[3] = "pikachu/wpn_deploy/deagle_deploy.ogg",
	[4] = "pikachu/wpn_deploy/p228_deploy.ogg",
	[5] = "pikachu/wpn_deploy/elite_deploy.ogg",
	[6] = "pikachu/wpn_deploy/fiveseven_deploy.ogg",
	[10] = "pikachu/wpn_deploy/m3_deploy.ogg",
	[11] = "pikachu/wpn_deploy/deagle_deploy.ogg",
	[20] = "pikachu/wpn_deploy/mp5_deploy.ogg",
	[22] = "pikachu/wpn_deploy/p90_deploy.ogg",
	[23] = "pikachu/wpn_deploy/mac10_deploy.ogg",
	[30] = "pikachu/wpn_deploy/ak47_deploy.ogg",
	[31] = "pikachu/wpn_deploy/sg552_deploy.ogg",
	[32] = "pikachu/wpn_deploy/m4a1_deploy.ogg",
	[33] = "pikachu/wpn_deploy/aug_deploy.ogg",
	[34] = "pikachu/wpn_deploy/scout_deploy.ogg",
	[35] = "pikachu/wpn_deploy/awp_deploy.ogg",
	[38] = "pikachu/wpn_deploy/galil_deploy.ogg",
	[39] = "pikachu/wpn_deploy/famas_deploy.ogg",
	[40] = "pikachu/wpn_deploy/m249_deploy.ogg",
	[50] = "pikachu/wpn_deploy/knife_deploy.ogg",
	[51] = "pikachu/wpn_deploy/he_deploy.ogg",
	[52] = "pikachu/wpn_deploy/he_deploy.ogg",
	[53] = "pikachu/wpn_deploy/he_deploy.ogg",
	[90] = "pikachu/wpn_deploy/m249_deploy.ogg",
	[91] = "pikachu/wpn_deploy/ak47_deploy.ogg",
}

-- Teammates only?
pikachu.wpnsnds.teamonly = true
-- Distance check in pixels
pikachu.wpnsnds.teamrange = 400
-- Extend to dead players spectating?
pikachu.wpnsnds.teamspec = true
-- Use exact player position instead of cache for distance checking?	
pikachu.wpnsnds.precisepos = false

-- Nothing to config past here

pikachu.wpnsnds.cache = {}

-- Check if setting is valid
pikachu.wpnsnds.teamrange = (type(pikachu.wpnsnds.teamrange) ~= "number" and 400) or (pikachu.wpnsnds.teamrange < 1 and 1) or pikachu.wpnsnds.teamrange

function pikachu.wpnsnds.isWithinDistance(x,y,refX,refY,distance)
    local dx, dy = (x - refX), (y - refY)
    local squaredDistance = dx ^ 2 + dy ^ 2
    return squaredDistance <= distance ^ 2
end

addhook("select","pikachu.wpnsnds.call")
function pikachu.wpnsnds.call(id,weapon)
	local i = pikachu.wpnsnds.cache[id]
	if i.lastwpn ~= weapon and pikachu.wpnsnds.wpntable[weapon] ~= nil then
		local x, y
		if pikachu.wpnsnds.precisepos then
			x, y = player(id,"x"), player(id,"y")
		else
			x, y = i.x, i.y
		end
		if pikachu.wpnsnds.teamonly then
			for a, b in pairs(pikachu.wpnsnds.cache) do
				local targetx, targety
				if pikachu.wpnsnds.precisepos then
					targetx, targety = player(a,"x"), player(a,"y")
				else
					targetx, targety = b.x, b.y
				end
				if i.team == b.team and pikachu.wpnsnds.isWithinDistance(x,y,targetx,targety,pikachu.wpnsnds.teamrange) then
					parse("sv_sound2 "..a.." \""..pikachu.wpnsnds.wpntable[weapon].."\"")
					-- Now check for all spectators spectating the person switching weapon and their allies
					if pikachu.wpnsnds.teamspec then
						for c, d in pairs(pikachu.wpnsnds.cache) do
							if d.dead and d.spec == a then
								parse("sv_sound2 "..c.." \""..pikachu.wpnsnds.wpntable[weapon].."\"")
							end
						end
					end
				end
			end
		else
			parse("sv_soundpos \""..pikachu.wpnsnds.wpntable[weapon].."\" "..x.." "..y)
		end
	end
	i.lastwpn = weapon
end

addhook("buy","pikachu.wpnsnds.call2p1")
addhook("drop","pikachu.wpnsnds.call2p1")
function pikachu.wpnsnds.call2p1(id)
	-- 10ms timer for checking player's equipped weapon
	timer(10,"pikachu.wpnsnds.call2p2",id)
end

function pikachu.wpnsnds.call2p2(id)
	id = tonumber(id)
	pikachu.wpnsnds.call(id,player(id,"weapontype"))
end

addhook("spawn","pikachu.wpnsnds.spawn")
function pikachu.wpnsnds.spawn(id)
	if not pikachu.wpnsnds.precisepos then
		pikachu.wpnsnds.cache[id].x = player(id,"x")
		pikachu.wpnsnds.cache[id].y = player(id,"y")
	end
	pikachu.wpnsnds.cache[id].dead = false
	pikachu.wpnsnds.call2p1(id)
end

addhook("die","pikachu.wpnsnds.reset")
function pikachu.wpnsnds.reset(id,k,wpn,x,y)
	if not pikachu.wpnsnds.precisepos then
		pikachu.wpnsnds.cache[id].x = x
		pikachu.wpnsnds.cache[id].y = y
	end
	pikachu.wpnsnds.cache[id].dead = true
	pikachu.wpnsnds.cache[id].lastwpn = 0
	if pikachu.wpnsnds.teamspec then
		pikachu.wpnsnds.cache[id].spec = player(id,"spectating")
	end
end

addhook("team","pikachu.wpnsnds.team")
function pikachu.wpnsnds.team(id,team)
	pikachu.wpnsnds.cache[id].team = team
	if pikachu.wpnsnds.teamspec then
		pikachu.wpnsnds.cache[id].spec = player(id,"spectating")
	end
end

if not pikachu.wpnsnds.precisepos then
	addhook("movetile","pikachu.wpnsnds.movetile")
end
function pikachu.wpnsnds.movetile(id,tx,ty)
	pikachu.wpnsnds.cache[id].x = tx * 32 + 16
	pikachu.wpnsnds.cache[id].y = ty * 32 + 16
end

if pikachu.wpnsnds.teamspec then
	addhook("specswitch","pikachu.wpnsnds.specswitch")
end
function pikachu.wpnsnds.specswitch(id,target)
	pikachu.wpnsnds.cache[id].spec = target
end

addhook("connect","pikachu.wpnsnds.connect")
function pikachu.wpnsnds.connect(id)
	pikachu.wpnsnds.cache[id] = {
		x = 0,
		y = 0,
		dead = false,
		team = 0,
		spec = 0,
		lastwpn = 0
	}
end

addhook("disconnect","pikachu.wpnsnds.disconnect")
function pikachu.wpnsnds.disconnect(id)
	pikachu.wpnsnds.cache[id] = nil
end

addhook("bombplant","pikachu.wpnsnds.bombplant")
function pikachu.wpnsnds.bombplant(id,x,y)
	parse("sv_soundpos \"pikachu/wpn_deploy/c4_plant.ogg\" "..(x*32+16).." "..(y*32+16))
end